text_value = {
              '<end>'               : 0x00,
              '<line>'              : 0x01,
              '<TERRA>'             : 0x02,
              '<LOCKE>'             : 0x03,
              '<CYAN>'              : 0x04,
              '<SHADOW>'            : 0x05,
              '<EDGAR>'             : 0x06,
              '<SABIN>'             : 0x07,
              '<CELES>'             : 0x08,
              '<STRAGO>'            : 0x09,
              '<RELM>'              : 0x0a,
              '<SETZER>'            : 0x0b,
              '<MOG>'               : 0x0c,
              '<GAU>'               : 0x0d,
              '<GOGO>'              : 0x0e,
              '<UMARO>'             : 0x0f,
              '<wait 60 frame>'     : 0x10,
              '<wait 1 frame>'      : 0x12,
              '<page>'              : 0x13,
              '<choice>'            : 0x15,
              '<GP>'                : 0x19,
              '<item>'              : 0x1a,
              '<skill>'             : 0x1b,
              '!'                   : 0x5e,
              '?'                   : 0x5f,
              '/'                   : 0x60,
              ':'                   : 0x61,
              '”'                   : 0x62,
              '\''                  : 0x63,
              '-'                   : 0x64,
              '.'                   : 0x65,
              ','                   : 0x66,
              '…'                   : 0x67,
              ';'                   : 0x68,
              '#'                   : 0x69,
              '+'                   : 0x6a,
              '('                   : 0x6b,
              ')'                   : 0x6c,
              '%'                   : 0x6d,
              '~'                   : 0x6e,
              '*'                   : 0x6f,
              '@'                   : 0x70,
              '<music note>'        : 0x71,
              '='                   : 0x72,
              '“'                   : 0x73,
              '<pearl>'             : 0x76,
              '<death>'             : 0x77,
              '<lightning>'         : 0x78,
              '<wind>'              : 0x79,
              '<earth>'             : 0x7a,
              '<ice>'               : 0x7b,
              '<fire>'              : 0x7c,
              '<water>'             : 0x7d,
              '<poison>'            : 0x7e,
              ' '                   : 0x7f,
              'e '                  : 0x80,
              ' t'                  : 0x81,
              ': '                  : 0x82,
              'th'                  : 0x83,
              't '                  : 0x84,
              'he'                  : 0x85,
              's '                  : 0x86,
              'er'                  : 0x87,
              ' a'                  : 0x88,
              're'                  : 0x89,
              'in'                  : 0x8a,
              'ou'                  : 0x8b,
              'd '                  : 0x8c,
              ' w'                  : 0x8d,
              ' s'                  : 0x8e,
              'an'                  : 0x8f,
              'o '                  : 0x90,
              ' h'                  : 0x91,
              ' o'                  : 0x92,
              'r '                  : 0x93,
              'n '                  : 0x94,
              'at'                  : 0x95,
              'to'                  : 0x96,
              ' i'                  : 0x97,
              ', '                  : 0x98,
              've'                  : 0x99,
              'ng'                  : 0x9a,
              'ha'                  : 0x9b,
              ' m'                  : 0x9c,
              'Th'                  : 0x9d,
              'st'                  : 0x9e,
              'on'                  : 0x9f,
              'yo'                  : 0xa0,
              ' b'                  : 0xa1,
              'me'                  : 0xa2,
              'y '                  : 0xa3,
              'en'                  : 0xa4,
              'it'                  : 0xa5,
              'ar'                  : 0xa6,
              'll'                  : 0xa7,
              'ea'                  : 0xa8,
              'I '                  : 0xa9,
              'ed'                  : 0xaa,
              ' f'                  : 0xab,
              ' y'                  : 0xac,
              'hi'                  : 0xad,
              'is'                  : 0xae,
              'es'                  : 0xaf,
              'or'                  : 0xb0,
              'l '                  : 0xb1,
              ' c'                  : 0xb2,
              'ne'                  : 0xb3,
              '\'s'                 : 0xb4,
              'nd'                  : 0xb5,
              'le'                  : 0xb6,
              'se'                  : 0xb7,
              ' I'                  : 0xb8,
              'a '                  : 0xb9,
              'te'                  : 0xba,
              ' l'                  : 0xbb,
              'pe'                  : 0xbc,
              'as'                  : 0xbd,
              'ur'                  : 0xbe,
              'u '                  : 0xbf,
              'al'                  : 0xc0,
              ' p'                  : 0xc1,
              'g '                  : 0xc2,
              'om'                  : 0xc3,
              ' d'                  : 0xc4,
              'f '                  : 0xc5,
              ' g'                  : 0xc6,
              'ow'                  : 0xc7,
              'rs'                  : 0xc8,
              'be'                  : 0xc9,
              'ro'                  : 0xca,
              'us'                  : 0xcb,
              'ri'                  : 0xcc,
              'wa'                  : 0xcd,
              'we'                  : 0xce,
              'Wh'                  : 0xcf,
              'et'                  : 0xd0,
              ' r'                  : 0xd1,
              'nt'                  : 0xd2,
              'm '                  : 0xd3,
              'ma'                  : 0xd4,
              'I\''                 : 0xd5,
              'li'                  : 0xd6,
              'ho'                  : 0xd7,
              'of'                  : 0xd8,
              'Yo'                  : 0xd9,
              'h '                  : 0xda,
              ' n'                  : 0xdb,
              'ee'                  : 0xdc,
              'de'                  : 0xdd,
              'so'                  : 0xde,
              'gh'                  : 0xdf,
              'ca'                  : 0xe0,
              'ra'                  : 0xe1,
              'n\''                 : 0xe2,
              'ta'                  : 0xe3,
              'ut'                  : 0xe4,
              'el'                  : 0xe5,
              '! '                  : 0xe6,
              'fo'                  : 0xe7,
              'ti'                  : 0xe8,
              'We'                  : 0xe9,
              'lo'                  : 0xea,
              'e!'                  : 0xeb,
              'ld'                  : 0xec,
              'no'                  : 0xed,
              'ac'                  : 0xee,
              'ce'                  : 0xef,
              'k '                  : 0xf0,
              ' u'                  : 0xf1,
              'oo'                  : 0xf2,
              'ke'                  : 0xf3,
              'ay'                  : 0xf4,
              'w '                  : 0xf5,
              '!!'                  : 0xf6,
              'ag'                  : 0xf7,
              'il'                  : 0xf8,
              'ly'                  : 0xf9,
              'co'                  : 0xfa,
              '. '                  : 0xfb,
              'ch'                  : 0xfc,
              'go'                  : 0xfd,
              'ge'                  : 0xfe,
              'e…'                  : 0xff,
             }
for ascii_val in range(ord('A'), ord('Z') + 1):
    text_value[chr(ascii_val)] = ascii_val - 0x21
for ascii_val in range(ord('a'), ord('z') + 1):
    text_value[chr(ascii_val)] = ascii_val - 0x27
for ascii_val in range(ord('0'), ord('9') + 1):
    text_value[chr(ascii_val)] = ascii_val + 0x24

# 0x11xx 0x14xx 0x16xx use two bytes
for frame_count in range(0x01, 0x100):
    text_value['<wait {} frames>'.format(frame_count * 15)] = 0x1100 | frame_count
for space_count in range(0x03, 0x20):
    text_value['<' + ' ' * space_count + '>'] = 0x1400 | space_count
for frame_count in range(0x01, 0x100):
    text_value['<wait for key {} frames>'.format(frame_count * 15)] = 0x1600 | frame_count

value_text = {v: k for k, v in text_value.items()}
