import pkgutil


ORIGINAL_COUNT = 7

id_palette = {
    0   : "Original 0",
    1   : "Original 1",
    2   : "Original 2",
    3   : "Original 3",
    4   : "Original 4",
    5   : "Original 5",
    6   : "Original 6",

    20  : "Aerith-HoxNorf-FF7",
    21  : "Ayla-CrumpledMedal-CT",
    22  : "Baram-PocoLoco-FF6",
    23  : "Barret-CtrlxZ-FF7",
    24  : "Bartz-HoxNorf-FF5",
    25  : "Berserker-Badass-FF5",
    26  : "Bird-JamesWhite89-FF6",
    27  : "Boco-JamesWhite89-FF5",
    28  : "Bomb-JamesWhite89-FF6",
    29  : "Bubble Dragon-Badass-BB",
    30  : "Cecil (Dark Knight)-MetroidQuest-EC",
    31  : "Cecil (Paladin)-MetroidQuest-EC",
    32  : "Chancellor-Zozma-FF6",
    33  : "Cid-HoxNorf-FF4",
    34  : "Cirno-HoxNorf-Touhou",
    35  : "Cloud-HoxNorf-FF7",
    36  : "Crono-Badass-CT",
    37  : "Devout-HoxNorf-FF",
    38  : "Edea-CtrlxZ-FF8",
    39  : "Edge-PocoLoco-FF4",
    40  : "Edward-SpoonyBard-FFRK",
    41  : "Edward-Zozma-FF4",
    42  : "Eiko-PocoLoco-FF9",
    43  : "Eiko-ScarabEnigma-FF9",
    44  : "Elarra-HoxNorf-FFRK",
    45  : "Exdeath-CtrlxZ-FF5",
    46  : "Faris (Summoner)-FEOK-FF5",
    47  : "Faris-HoxNorf-FF5",
    48  : "Fish-ScarabEnigma-FF6",
    49  : "Freya-HoxNorf-FF9",
    50  : "Frog-Badass-CT",
    51  : "Frog-MetroidQuest-EC",
    52  : "FuSoYa-FEOK-FF4",
    53  : "Galuf-HoxNorf-FF5",
    54  : "Gardevoir-LoneRedMage-Pokemon",
    55  : "Garnet-HoxNorf-FF9",
    56  : "Gau (Suit)-Zozma-FF6",
    57  : "General Leo (Full)-SpoonyBard-FF6",
    58  : "General Leo (Redone)-SpoonyBard-FF6",
    59  : "Gestahl-MetroidQuest-EC",
    60  : "Gilgamesh-Kugawattan-FF5",
    61  : "Golbez-FEOK-FF4",
    62  : "Iffy-HoxNorf-Neptunia",
    63  : "Impressario-LoneRedMage-FF6",
    64  : "Interceptor-JamesWhite89-FF6",
    65  : "Iris-HoxNorf-FF15",
    66  : "Jessie-HoxNorf-FF7",
    67  : "Kain-MetroidQuest-EC",
    68  : "Kain-SpoonyBard-FFRK",
    69  : "Katarin-Zozma-FF6",
    70  : "Kelgar-CtrlxZ-FF5",
    71  : "King Baron-JamesWhite89-FF4",
    72  : "Krile-HoxNorf-FF5",
    73  : "Laguna-PocoLoco-FF8",
    74  : "Lenna (White Mage)-HoxNorf-FF5",
    75  : "Lenna-HoxNorf-FF5",
    76  : "Lightning-FEOK-FF13",
    77  : "Magus-FEOK-CT",
    78  : "Magus-MetroidQuest-EC",
    79  : "Mini-JamesWhite89-FF",
    80  : "Mog-JamesWhite89-FF6E",
    81  : "Mystic Knight-CtrlxZ-FF5",
    82  : "Nepgear-HoxNorf-Neptunia",
    83  : "Neptune (Adult)-HoxNorf-Neptunia",
    84  : "Neptune-HoxNorf-Neptunia",
    85  : "Ninja-CtrlxZ-FF5",
    86  : "Onion Knight-FEOK-FF3",
    87  : "Palom-HoxNorf-FF4",
    88  : "Porom-HoxNorf-FF4",
    89  : "Quina-SpoonyBard-FFRK",
    90  : "Quistis-FEOK-FF8",
    91  : "Rachel-Zozma-FF6",
    92  : "Relm (Amano)-HoxNorf-FF6",
    93  : "Relm-MetroidQuest-EC",
    94  : "Reno-CtrlxZ-FF7",
    95  : "Robo-Badass-CT",
    96  : "Rosa-PocoLoco-FF4",
    97  : "Rydia (Child)-HoxNorf-FF4",
    98  : "Rydia-HoxNorf-FF4",
    99  : "Rydia-Zozma-FF4",
    100 : "Ryu (Dragon)-Badass-BOF",
    101 : "Ryu-Badass-BOF",
    102 : "Samurai-CtrlxZ-FF5",
    103 : "Schala-HoxNorf-CT",
    104 : "Sephiroth-CtrlxZ-FF7",
    105 : "Seymour-LoneRedMage-FF10",
    106 : "Shantotto-HoxNorf-FF11",
    107 : "Soldier-LoneRedMage-FF4",
    108 : "Steiner-FEOK-FF9",
    109 : "Tellah-FEOK-FF4",
    110 : "Terra (Amano Blond Cape)-JCollins-FF6",
    111 : "Terra (Amano Cape)-JCollins-FF6",
    112 : "Terra (Amano)-JCollins-FF6",
    113 : "Terra-MetroidQuest-EC",
    114 : "Tiny Moogle-Rjenyawd-FF",
    115 : "Tohka-HoxNorf-DAL",
    116 : "Tonberry-JamesWhite89-FF",
    117 : "Ultros-PocoLoco-FF6",
    118 : "Uni-HoxNorf-Neptunia",
    119 : "Vanille-FEOK-FF13",
    120 : "Vivi-PocoLoco-FF9",
    121 : "White Mage-Matthew50-FF",
    122 : "Yang-SApprentice-FF4",
    123 : "Yuffie-HoxNorf-FF7",
    124 : "Zack-CtrlxZ-FF7",
    125 : "Zidane-HoxNorf-FF9",
    126 : "Kuja-HoxNorf-FF9",
    127 : "Reimu-HoxNorf-Touhou",
    128 : "Ram-HoxNorf-Neptunia",
    129 : "Rom-HoxNorf-Neptunia",
    130 : "Umaro (Morph)-CDude-FF6",
    131 : "Sarisa-HoxNorf-FF5",
    132 : "Lilith-HoxNorf-Darkstalkers",
    133 : "Marisa-HoxNorf-Touhou",
    135 : "Rumia-HoxNorf-Touhou",
    134 : "Papyrus-LoneRedMage-Undertale",
    136 : "Sans-LoneRedMage-Undertale",
    137 : "Toadette-HoxNorf-Mario",
    138 : "Talim-HoxNorf-SC4",
    139 : "Katt-ATinySpook-BOF2",
    140 : "Steve-PheonixMMKC777-Minecraft",
    141 : "Tonberry King-CDude-FF",
    142 : "Banjo Kazooie-HoxNorf-BK",
    143 : "PajaMog-CDude-FF",
    144 : "GrimLocke-Taloswind-FF6",
    145 : "Emperor-HoxNorf-FF2",
    146 : "Chen-HoxNorf-Touhou",
    147 : "Selphie-HoxNorf-FF8",
    148 : "Sora-HoxNorf-KH",
    
    200 : "Flandre-HoxNorf-Touhou",
    201 : "Porom-Devout-HoxNorf-FF4",
    202 : "Remilia-HoxNorf-Touhou",
    203 : "Reisen-HoxNorf-Touhou",
    204 : "Cid-doubledown-FF6",
    205 : "Golbez_TAY-HoxNorf-FF4",
    206 : "Palom_Magus-HoxNorf-FF4",
    207 : "Patchouli-HoxNorf-Touhou",
    208 : "Suwako-HoxNorf-Touhou",
    209 : "Eiko_Miko-ScarabEnigma-FF9",
    
    210 : "Akari-HoxNorf-LB",
    211 : "Angeal-HoxNorf-FF7",
    212 : "Bombette-HoxNorf-Mario",
    213 : "Bowser-Badass-Mario",
    214 : "Cammy-Quikdraw7777-SF",
    215 : "Captain Falcon-JamesWhite89-FZero",
    216 : "Ceodore-HoxNorf-FF4",
    217 : "Chun Li-Quikdraw7777-SF",
    218 : "Eggman-JamesWhite89-Sonic",
    219 : "Fighter-CtrlxZ-FF1",
    220 : "Firion-HoxNorf-FF2",
    221 : "Genesis-HoxNorf-FF7",
    222 : "Gordon-HoxNorf-FF2",
    223 : "Guy-HoxNorf-FF2",
    224 : "Hotaru-HoxNorf-MOTW",
    225 : "Josef-HoxNorf-FF2",
    226 : "Knuckles-Jameswhite89-Sonic",
    227 : "Laguna-HoxNorf-FF8",
    228 : "Leila-HoxNorf-FF2",
    229 : "Leon-HoxNorf-FF2",
    230 : "Maria-HoxNorf-FF2",
    231 : "Metal Sonic-JamesWhite89-Sonic",
    232 : "Minwu-HoxNorf-FF2",
    233 : "Pacman Ghost-HoxNorf-Pacman",
    234 : "Palom (Adult)-HoxNorf-FF4",
    235 : "Paul-HoxNorf-FF2",
    236 : "Piranha Plant-JamesWhite89-Mario",
    237 : "Porom (Adult)-HoxNorf-FF4",
    238 : "Ramza-CtrlxZ-FFT",
    239 : "Ricard-HoxNorf-FF2",
    240 : "Ryu-Quikdraw7777-SF",
    241 : "Scott-HoxNorf-FF2",
    242 : "Tails-JamesWhite89-Sonic",
    243 : "Thief-CtrlxZ-FF1",
    244 : "Ursula-HoxNorf-FF4",
    245 : "Wolf-HoxNorf-Starfox",
    246 : "Futo-HoxNorf-Touhou",
    247 : "Kaguya-HoxNorf-Touhou",
    248 : "Reimu2-HoxNorf-Touhou",
    249 : "Antlion-Astaroth-FF4",
    250 : "Arvis-PocoLoco-FF6",
    251 : "Atma-Astaroth-FF6",
    252 : "Beatrix-PocoLoco-FF9",
    253 : "Boy-Zozma-FF6",
    254 : "Cagnazzo-Astaroth-FF4",
    255 : "Celes (Amano)-Astaroth-FF6",
    256 : "Celes (Opera)-Astaroth-FF6",
    257 : "Clyde-PocoLoco-FF6",
    258 : "Cultist-PocoLoco-FF6",
    259 : "Dancer-PocoLoco-FF6",
    260 : "Dark Elf-Astaroth-FF4",
    261 : "Draco-PocoLoco-FF6",
    262 : "Elena-Astaroth-FF7",
    263 : "Figaro Guard-PocoLoco-FF6",
    264 : "Granny-Zozma-FF6",
    265 : "Hojo-LoneRedMage-FF7",
    266 : "Sanae-HoxNorf-Touhou",
    267 : "Lady-Zozma-FF6",
    268 : "Link-FEOK-LegendOfZelda",
    269 : "LoneWolf-PocoLoco-FF6",
    270 : "Lucca-FEOK-CT",
    271 : "Lufia-JamesWhite89-Lufia",
    272 : "Luigi-Badass-Mario",
    273 : "Maduin-PocoLoco-FF6",
    274 : "Mario-Badass-Mario",
    275 : "Kain (Holy Dragoon)-CtrlxZ-FF4TAY",
    276 : "NarsheGuard-PocoLoco-FF6",
    277 : "Peach-Halkel-SMRPG",
    278 : "Returner-PocoLoco-FF6",
    279 : "Rubicante-Astaroth-FF4",
    280 : "Scholar-PocoLoco-FF6",
    281 : "Seifer-Filipinac-FF8",
    282 : "Siegfried-PocoLoco-FF6",
    283 : "Slash-Badass-CT",
    284 : "Sonic-Badass-Sonic",
    285 : "Squall (Uniform)-SApprentice-FF8",
    286 : "Squall-PocoLoco-FF8",
    287 : "Tifa-Astaroth-FF7",
    288 : "Train Conductor-Zozma-FF6",
    289 : "Vargas-PocoLoco-FF6",
    290 : "Vincent-FEOK-FF7",
    291 : "Yoshi-Badass-Mario",

    # FFT
    300 : "Alma-HoxNorf-FFT",
    301 : "Orlandeau-ctrlxz-FFT",

    302 : "Alice-HoxNorf-Touhou",
    303 : "Alphys-LoneRedMage-Undertale",
    304 : "Amy-HoxNorf-Sonic",
    305 : "Frisk-LoneRedMage-Undertale",
    306 : "Gryz-HoxNorf-PS4",
    307 : "Raja-HoxNorf-PS4",
    308 : "Reimu (Blue)-HoxNorf-Touhou",
    309 : "Rune-HoxNorf-PS4",
    310 : "Toriel-LoneRedMage-Undertale",
    311 : "Yuyuko-HoxNorf-Touhou",
    312 : "Cait Sith-HoxNorf-FF7",
    313 : "Wren-HoxNorf-PS4",
    314 : "Nitori-HoxNorf-Touhou",
    315 : "Donkey Kong-Badass-Mario",
    316 : "X-Badass-Megaman",
    317 : "Lugae-Astaroth-FF4",
    318 : "Gilius-JamesWhite89-GoldenAxe",
    319 : "Arthur-JamesWhite89-GnG",
    320 : "Sherlotta-HoxNorf_ScarabEnigma-FFCC",
    321 : "Purple Sister-HoxNorf-Neptunia",
    322 : "Noire-HoxNorf-Neptunia",
    323 : "Arle-HoxNorf-Madou",
    324 : "Simon-JamesWhite89-Castlevania",
    325 : "Aria-HoxNorf-FF3",
    326 : "Refia-HoxNorf-FF3",
    327 : "Nakoruru-HoxNorf-SamSho",
    328 : "Rash-JamesWhite89-Battletoads",
    329 : "Marle-CtrlxZ-CT",
    330 : "Relm-HoxNorf-FF6PR",
    331 : "Tina-CtrlxZ-FF6",
    332 : "Luneth-HoxNorf-FF3",
    333 : "Malin-HoxNorf-KOF",
    334 : "Toadette (Explorer)-HoxNorf-Mario",
    335 : "Blaze-HoxNorf-Sonic",
    336 : "Xion-Kzinssie-KH",
    337 : "Tohka (Spirit)-HoxNorf-DAL",
    338 : "Satori-HoxNorf-Touhou",
    339 : "Lenna (Dancer)-HoxNorf-FF5",
    340 : "Lenna (Time Mage)-HoxNorf-FF5",
    341 : "Lenna (Ranger)-HoxNorf-FF5",
    342 : "Ness-Badass-Mother",
    343 : "Doom Guy-JamesWhite89-Doom",
    344 : "Cleon (Player 1)-HoxNorf-PB4",
    345 : "Cleon (Player 2)-HoxNorf-PB4",
    346 : "Koishi-HoxNorf-Touhou",
    347 : "Yamame-HoxNorf-Touhou",
    348 : "Suika-HoxNorf-Touhou",
    349 : "Eirin-HoxNorf-Touhou",
    350 : "Riku-HoxNorf-KH",
    351 : "Daryl-IvaarForkbeard_Odbarc-FF6",
    352 : "Samus-Badass-Metroid",
    353 : "Ridley-JamesWhite89-Metroid",
    354 : "Marth-HoxNorf-FE",
    355 : "Bartz (Knight)-HoxNorf-FF5",
    356 : "Lenna (Knight)-HoxNorf-FF5",
    357 : "Lenna (Thief)-HoxNorf-FF5",
    358 : "Lenna (Summoner)-HoxNorf-FF5",
    359 : "Lenna (Beastmaster)-HoxNorf-FF5",
}


def get_path(id_: int) -> str:
    if id_ < ORIGINAL_COUNT:
        subdir = "original"
    else:
        subdir = "custom"

    name = id_palette[id_]
    return f"{subdir}/{name}.pal"


def get_palette_data(path: str) -> bytes:
    data = pkgutil.get_data(__name__, path)
    assert data, f"no palette data {path=} {__name__=}"
    return data
