# list of tiles in each character pose from 0xc0ce3a in rom
# this does not include dead horizontal or riding poses
CHARACTER = [
    [
        [0x00, 0x01],
        [0x02, 0x03],
        [0x04, 0x05],
    ],
    [
        [0x00, 0x01],
        [0x06, 0x07],
        [0x08, 0x09],
    ],
    [
        [0x00, 0x01],
        [0x0a, 0x0b],
        [0x04, 0x05],
    ],
    [
        [0x0c, 0x0d],
        [0x0e, 0x0f],
        [0x10, 0x11],
    ],
    [
        [0x0c, 0x0d],
        [0x12, 0x13],
        [0x14, 0x15],
    ],
    [
        [0x0c, 0x0d],
        [0x16, 0x17],
        [0x10, 0x11],
    ],
    [
        [0x18, 0x19],
        [0x1a, 0x1b],
        [0x1c, 0x1d],
    ],
    [
        [0x1e, 0x1f],
        [0x20, 0x21],
        [0x22, 0x23],
    ],
    [
        [0x18, 0x19],
        [0x24, 0x25],
        [0x26, 0x27],
    ],
    [
        [0x38, 0x39],
        [0x3a, 0x3b],
        [0x3c, 0x3d],
    ],
    [
        [0x3e, 0x3f],
        [0x40, 0x41],
        [0x42, 0x43],
    ],
    [
        [0x44, 0x45],
        [0x46, 0x47],
        [0x48, 0x49],
    ],
    [
        [0x1e, 0x1f],
        [0x28, 0x29],
        [0x2a, 0x2b],
    ],
    [
        [0x18, 0x19],
        [0x2c, 0x1b],
        [0x2d, 0x1d],
    ],
    [
        [0x18, 0x2e],
        [0x2f, 0x30],
        [0x31, 0x32],
    ],
    [
        [0x1e, 0x33],
        [0x34, 0x35],
        [0x36, 0x37],
    ],
    [
        [0x4a, 0x4b],
        [0x4c, 0x4d],
        [0x4e, 0x4f],
    ],
    [
        [0x4a, 0x4b],
        [0x50, 0x4d],
        [0x4e, 0x4f],
    ],
    [
        [0x51, 0x52],
        [0x53, 0x54],
        [0x55, 0x56],
    ],
    [
        [0x00, 0x01],
        [0x5d, 0x5e],
        [0x08, 0x09],
    ],
    [
        [0x00, 0x01],
        [0x06, 0x5f],
        [0x08, 0x09],
    ],
    [
        [0x96, 0x1f],
        [0x97, 0x21],
        [0x22, 0x23],
    ],
    [
        [0x6a, 0x6b],
        [0x6c, 0x6d],
        [0x6e, 0x6f],
    ],
    [
        [0x70, 0x71],
        [0x72, 0x73],
        [0x74, 0x75],
    ],
    [
        [0x76, 0x77],
        [0x78, 0x79],
        [0x7a, 0x7b],
    ],
    [
        [0x6a, 0x01],
        [0x6c, 0x07],
        [0x6e, 0x09],
    ],
    [
        [0x82, 0x01],
        [0x83, 0x07],
        [0x6e, 0x09],
    ],
    [
        [0x0c, 0x71],
        [0x12, 0x73],
        [0x14, 0x75],
    ],
    [
        [0x0c, 0x84],
        [0x12, 0x85],
        [0x14, 0x75],
    ],
    [
        [0x60, 0x61],
        [0x62, 0x63],
        [0x64, 0x65],
    ],
    [
        [0x66, 0x67],
        [0x68, 0x69],
        [0x64, 0x65],
    ],
    [
        [0x7c, 0x7d],
        [0x7e, 0x7f],
        [0x80, 0x81],
    ],
    [
        [0x86, 0x87],
        [0x88, 0x89],
        [0x08, 0x09],
    ],
    [
        [0x8a, 0x8b],
        [0x8c, 0x8d],
        [0x14, 0x15],
    ],
    [
        [0x8e, 0x8f],
        [0x90, 0x91],
        [0x22, 0x23],
    ],
    [
        [0x92, 0x93],
        [0x94, 0x95],
        [0x08, 0x09],
    ],
    [
        [0xa3, 0xa4],
        [0x98, 0x99],
        [0x9a, 0x9b],
    ],
    [
        [0xa3, 0xa4],
        [0x9c, 0x99],
        [0x9a, 0x9b],
    ],
    [
        [0x9d, 0x9e],
        [0x9f, 0xa0],
        [0xa1, 0xa2],
    ],
    [
        [0xa5, 0xa6],
        [0xa7, 0xa8],
        [0xa9, 0xaa],
    ],
    [
        [0x57, 0x58, 0x59],
        [0x5a, 0x5b, 0x5c],
    ],
    [
        [0x31, 0x32],
        [0x33, 0x34],
        [0x35, 0x36],
    ],
    [
        [0x28, 0x01],
        [0x29, 0x07],
        [0x2a, 0x09],
    ],
    [
        [0x2b, 0x01],
        [0x2c, 0x07],
        [0x2a, 0x09],
    ],
    [
        [0x2d, 0x2e],
        [0x2f, 0x30],
        [0x08, 0x09],
    ],
    [
        [0x28, 0x29],
        [0x2a, 0x2b],
        [0x2c, 0x2d],
    ],
    [
        [0xb1, 0xb2],
        [0xb3, 0xb4],
        [0xaf, 0xb0],
    ],
    [
        [0xab, 0xac],
        [0xad, 0xae],
        [0xaf, 0xb0],
    ],
    [
        [0x06, 0x01],
        [0x07, 0x03],
        [0x08, 0x05],
    ],
    [
        [0x09, 0x0a],
        [0x02, 0x03],
        [0x04, 0x05],
    ],
    [
        [0x00, 0x00],
        [0x01, 0x02],
        [0x03, 0x04],
    ],
    [
        [0x00, 0x00],
        [0x05, 0x06],
        [0x07, 0x08],
    ],
    [
        [0x00, 0x00],
        [0x09, 0x0a],
        [0x0b, 0x0c],
    ],
    [
        [0x00, 0x00],
        [0x0d, 0x0e],
        [0x0f, 0x10],
    ],
    [
        [0x2e, 0x2f],
        [0x30, 0x31],
        [0x32, 0x33],
    ],
    [
        [0x34, 0x35],
        [0x36, 0x37],
        [0x32, 0x33],
    ],
    [
        [0x34, 0x35],
        [0x36, 0x37],
        [0x32, 0x33],
    ],
    [
        [0x00, 0x01],
        [0x02, 0x02],
        [0x02, 0x02],
    ],
]

RIDING0 = [
    [0xab, 0xac],
    [0xad, 0xae],
    [0xaf, 0xb0],
]

RIDING1 = [
    [0xb1, 0xb2],
    [0xb3, 0xb4],
    [0xaf, 0xb0],
]

DEAD_HORIZONTAL = [
    [0x57, 0x58, 0x59],
    [0x5a, 0x5b, 0x5c],
]

PORTRAIT = [
    [ 0,  1,  2,  3,  8],
    [16, 17, 18, 19,  9],
    [ 4,  5,  6,  7, 10],
    [20, 21, 22, 23, 11],
    [13, 14, 15, 24, 12],
]

STANDING_FRONT = CHARACTER[1]
