# Final Fantasy 6 Worlds Collide

## Where is the settings page?

The [player settings page for this game](../player-settings) contains all the options you need to configure and export a
config file.

## What does randomization do to this game?

Players begin aboard the airship and can travel freely between the World of Balance and the World of Ruin to discover characters, Espers, and items before facing off against Kefka.
Worlds Collide provides countless possible variations, including starting characters; character stats, equipability, commands, and natural magic; battle reward multipliers; bosses and encounters; and Esper spells, bonuses, and equipability. The Goal can be adjusted by changing the objective required to reach Kefka, such as number of characters found, number Espers found, number of dragons defeated, and/or number of bosses defeated.

## What items and locations get shuffled?

All characters, Espers, equipment, and items are shuffled. All of the major checks in Worlds Collide are locations. Examples of major checks include Ancient Castle, Auction House, Baren Falls, Burning House, and so on. Furthermore, if Treasuresanity is turned on, all minor checks will also be added to the location pool, including barrels, chests, clocks, crates, pots, and stoves. Characters and Espers found in minor checks and certain major checks will display as "ArchplgoItem".

## Which items can be in another player's world?

Any of the characters, Espers, equipment, and items which can be shuffled may also be placed into another player's world.

## What does another world's item look like in Final Fantasy 6 Worlds Collide?

All items from other games will display as "ArchplgoItem", including those from other Final Fantasy 6 Worlds Collide games.

## When the player receives an item, what happens?

When the player receives an item, it will go into your inventory. However, items are not received while in battle or while walking on the overworld. Currently, there is no notification when an item is received, so it is recommended to keep a text client open.

- Note: You cannot receive items from the multiworld while in the Moogle Defense event room until after the event is complete.
  So, just in case that room happens to be your favorite grinding spot, be aware that you might not receive items until you leave the room.
  - (This is because receiving some items (characters) during the Moogle Defense event could be buggy.)

## I received an item from another player, but it has not appeared in my inventory yet, what can I do?

If you are in the overworld, try returning to the waiting area of the airship. Items are not received while in battle or while walking on the overworld.


## I have "ArchplgoItem" in my inventory, what are these?

When another player's item is received, an ArchplgoItem is added to your inventory. These can be used as Rename Cards to change the name of a character or sold at a store for a small amount of GP.

## Where can I find more information about Worlds Collide or custom Flagstrings?

Visit the [Worlds Collide Wiki](https://wiki.ff6worldscollide.com/).

## What version of Worlds Collide is this based on?

Currently, we are using version 1.4.2.
